#!/usr/bin/python

import sys
import Parameters, Runner


if __name__ == '__main__' :
    example="""
PANNZER2 function prediction: 
        python %s -m Pannzer -s "Pusa hispida saimensis" < querysequences.fasta
	- query species given by -s argument
        - output goes to STDOUT and files Pannzer.out_1, Pannzer.out_2, Pannzer.out_3

	python %s -m Pannzer -i querysequences.fasta -o 'sans.tab,DE.out,GO.out,anno.out'
	- query species parsed from Uniprot header
	- output goes to files sans.tab,DE.out,GO.out,anno.out

More options:
	python %s -h

More info:
	http://ekhidna2.biocenter.helsinki.fi/sanspanz

""" %(sys.argv[0],sys.argv[0],sys.argv[0])
    if len(sys.argv)==1: 
	sys.stderr.write("%s\n" %example)
	exit()
    glob=Parameters.WorkSpace()
    z=Runner.Runner(glob,operator_name=glob.param['input_OPERATOR'],CHUNK=glob.param['input_CHUNK'],liveData=glob.param['input_LIVEDATA'])
    z.lazyRunner(glob.param['input_FILE'], glob.param['input_OUTFILES'].split(","), queryspecies=glob.param['input_QUERYSPECIES'],colnames=glob.param['input_COLNAMES'], block_column_name=glob.param['input_BLOCK_COLUMN_NAME'], input_format=glob.param['input_FORMAT'] )

